'use strict';

var _proxyAgent = require('proxy-agent');

var _proxyAgent2 = _interopRequireDefault(_proxyAgent);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _url = require('url');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = (0, _debug2.default)('proxy-scraper:worker:' + process.argv[2]);

log('Worker started !');

var page = void 0;

process.on('message', function (msg) {
	switch (msg.event) {
		case 'test':
			testProxy(msg.data);
			break;
		case 'page':
			page = msg.data;
			break;
	}
});

function testProxy(_ref) {
	var url = _ref.url,
	    method = _ref.method,
	    proxy = _ref.proxy,
	    timeout = _ref.timeout;

	log('testing %s with proxy %s and %s ms of timeout', url, proxy, timeout);
	var startTime = Date.now();
	var p = (0, _url.parse)(proxy);
	p.timeout = timeout;
	(0, _nodeFetch2.default)(url, {
		method: method || 'GET',
		agent: new _proxyAgent2.default(p),
		timeout: timeout
	}).then(function (res) {
		if (page) {
			return res.text().then(function (p) {
				if (p != page) {
					var e = new Error('Page content missmatch');
					e.type = 'missmatch';
					throw e;
				}
			});
		}
	}).then(function () {
		return process.send({ working: true, time: Date.now() - startTime });
	}).catch(function (error) {
		return process.send({ error: error, working: false });
	});
}